package dev.shadowsoffire.apotheosis.spawn.compat;

import net.minecraft.client.gui.screens.Screen;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.network.chat.Component;
import java.util.function.Consumer;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStats;
import java.util.Objects;
import net.minecraftforge.fml.loading.FMLEnvironment;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import mcjty.theoneprobe.api.IProbeHitData;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import mcjty.theoneprobe.api.IProbeInfo;
import mcjty.theoneprobe.api.ProbeMode;
import dev.shadowsoffire.placebo.compat.TOPCompat;

public class SpawnerTOPPlugin implements TOPCompat.Provider
{
    public static void register() {
        TOPCompat.registerProvider((TOPCompat.Provider)new SpawnerTOPPlugin());
    }
    
    public void addProbeInfo(final ProbeMode mode, final IProbeInfo info, final Player player, final Level level, final BlockState state, final IProbeHitData hitData) {
        final BlockEntity 7702_ = level.m_7702_(hitData.getPos());
        if (7702_ instanceof final ApothSpawnerTile spw) {
            if (FMLEnvironment.dist.isDedicatedServer() || ClientAccess.hasControlDown()) {
                final ApothSpawnerTile apothSpawnerTile = spw;
                Objects.requireNonNull(info);
                SpawnerStats.generateTooltip(apothSpawnerTile, (Consumer)info::mcText);
            }
            else {
                info.mcText((Component)Component.m_237115_("misc.apotheosis.ctrl_stats"));
            }
        }
    }
    
    private static class ClientAccess
    {
        public static boolean hasControlDown() {
            return Screen.m_96637_();
        }
    }
}
